package indep_set.LaTeX;

public class TikZ {
	
	static final String BEGIN_TIKZPICTURE = "\\begin{tikzpicture}[S]";
	static final String END_TIKZPICTURE = "\\end{tikzpicture}";
	static final String NODE = "\\node";
	static final String RECTANGLE = "rectangle";
	static final String AT  = "at";
	static final String DRAW = "\\draw";
	static final String PATH = "\\path";
	static final String TO = "--";
	static final String TAB = "\t";
	static final String USE_AS_BOUNDINGBOX = "[use as bounding box]";
	
	protected StringBuilder code = new StringBuilder();
	
	public TikZ(){
		code.append(BEGIN_TIKZPICTURE + "\n");
	}
	
	@Override
	public String toString(){
		return code.toString();
	}
	
	protected void addCommentLine(String s){
		code.append("%" + TAB + s + "\n");
	}
	
	protected void addBoundingBox(double x1, double x2, double y1, double y2){
		code.append(TAB + " " + PATH + USE_AS_BOUNDINGBOX + " (" + x1 + "," + y1 + ") "
				+ RECTANGLE + " (" + x2 + "," + y2 + ");\n");
	}
	
	protected void addNode(String name, double x, double y, String text){
		code.append(TAB + " " + NODE + "[V] (" + name + ") " 
				   + AT + " (" + x + "," + y + ")" + " {" + text + "};\n");
	}
	
	protected void addDrawEdge(String node1Name, String node2Name){
		code.append(TAB + " " + DRAW + " (" + node1Name + ") " + TO + " (" + node2Name + ");\n");
	}
	
	protected void finish(){
		code.append(END_TIKZPICTURE);
	}
	
	

}
